#include <iostream>
#include <vector>
#include <set>
#include <cmath>

#define MAXN 1024

using namespace std;

int n, m;

char a[MAXN][MAXN];
vector<int>s[MAXN];

vector<int>bs[MAXN];

int r[MAXN], rn;

set<int>used;

set<int>::iterator it, pre, nex;

int col, prec, nexc;

long long ans;

int lz[MAXN][MAXN], rz[MAXN][MAXN];
int q, ci, cj, lg[MAXN], rg[MAXN];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("rectcnt19.in", "r", stdin);
    //freopen("rectcnt19.out", "w", stdout);

    cin >> n >> q; m = n;
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        s[i].push_back(m);
        for (int j = m - 1; j >= 0; --j) if (a[i][j] == '1') s[i].push_back(j);
        int temp = 0;
        for (int j = 0; j < m; ++j)
        {
            if (a[i][j] == '0') lz[i][j] = temp++;
            else temp = 0;
        }
        temp = 0;
        for (int j = m - 1; j >= 0; --j)
        {
            if (a[i][j] == '0') rz[i][j] = temp++;
            else temp = 0;
        }
    }

    for (int j = 0; j < m; ++j)
    {
        for (int i = 0; i < n; ++i)
        {
            if (s[i].back() < j) s[i].pop_back();
            bs[s[i].back()].push_back(i);
        }
        rn = 0;
        for (int i = j; i <= m; ++i)
        {
            while (!bs[i].empty())
            {
                r[rn++] = bs[i].back();
                bs[i].pop_back();
            }
        }
        used.clear();
        used.insert(-1);
        used.insert(n);
        for (int i = 0; i < rn; ++i)
        {
            pre = nex = used.insert(r[i]).first;
            --pre; if (*pre == -1) prec = j; else prec = s[*pre].back();
            ++nex; if (*nex == n) nexc = j; else nexc = s[*nex].back();
            col = max(prec, nexc);
            ans += (*nex - *pre) * (*nex - *pre - 1) / 2 * (s[r[i]].back() - col);

        }
    }

    cout << ans << "\n";

    while (q--)
    {
        int top, bot, lrow, rrow;
        long long cnt = 0, gcnt = 0, lcnt = 0, rcnt = 0;
        cin >> ci >> cj;
        if (cj == 0 || a[ci][cj-1] == '1') lg[ci] = 0;
        else lg[ci] = lz[ci][cj-1] + 1;
        if (cj == m - 1 || a[ci][cj+1] == '1') rg[ci] = 0;
        else rg[ci] = rz[ci][cj+1] + 1;
        for (top = ci - 1; top >= 0; --top)
        {
            if (a[top][cj] == '1') break;
            lg[top] = min (lz[top][cj], lg[top + 1]);
            rg[top] = min (rz[top][cj], rg[top + 1]);
        }
        for (bot = ci + 1; bot < m; ++bot)
        {
            if (a[bot][cj] == '1') break;
            lg[bot] = min(lz[bot][cj], lg[bot - 1]);
            rg[bot] = min(rz[bot][cj], rg[bot - 1]);
        }
        ++top; --bot;
        lrow = rrow = bot;
        for (int i = top; i <= ci; ++i)
        {
            while (lg[lrow] < lg[i])
            {
                if (lrow > rrow) { cnt += (lg[lrow] + 1) * (rg[lrow] + 1); rcnt -= rg[lrow] + 1; }
                else { lcnt += lg[lrow] + 1; }
                --lrow;
            }
            while (rg[rrow] < rg[i])
            {
                if (rrow > lrow) { cnt += (lg[rrow] + 1) * (rg[rrow] + 1); lcnt -= lg[rrow] + 1; }
                else { rcnt += rg[rrow] + 1; }
                --rrow;
            }
            gcnt += cnt + lcnt * (rg[i] + 1) + rcnt * (lg[i] + 1) + (min(lrow, rrow) - ci + 1) * (lg[i] + 1) * (rg[i] + 1);
        }
        if (a[ci][cj] == '1') { ans += gcnt; a[ci][cj] = '0'; }
        else { ans -= gcnt; a[ci][cj] = '1'; }
        int temp = 0;
        for (int j = 0; j < m; ++j)
        {
            if (a[ci][j] == '0') lz[ci][j] = temp++;
            else temp = 0;
        }
        temp = 0;
        for (int j = m - 1; j >= 0; --j)
        {
            if (a[ci][j] == '0') rz[ci][j] = temp++;
            else temp = 0;
        }
        cout << ans << "\n";
    }

    return 0;
}
